#include <dos.h>
#include <stdlib.h>
#include <math.h>

char far *vga = MK_FP(0xA000, 0);
const float PI = 3.1415927;
int CosArray[360], SinArray[360];

unsigned char *Virtual = NULL; // virtual screens

/*
	These routines are from earlier parts of the tutorial
*/
void SetMode13h()
{
	union REGS regs;
	regs.x.ax = 0x013;
	int86(0x10, &regs, &regs);
}

void SetTextMode()
{
	union REGS regs;
	regs.x.ax = 0x003;
	int86(0x10, &regs, &regs);
}

// Generate our arrays of SIN and COS values
void LoadCircleArrays()
{
	int a;
	float radians;

	for(a = 0; a < 360; a++)
	{
		radians = (float)a * PI / 180;
		CosArray[a] = (int)(cos(radians) * 100);
		SinArray[a] = (int)(sin(radians) * 100);
	}
}

/*
	The following are our former routines modified to support virtual screens
*/
void PlotPixel(int x, int y, int colour, unsigned char *where)
{  
	*(where+(y*320)+x)=colour;
}

// Draws a hollow circle
void Circle(int xc, int yc, int r, int color, unsigned char *where)
{
	int x,y,s;

	for(s = 0; s < 360; s++)
	{
		x = xc + ( ( r * CosArray[s] ) / 100 );
		y = yc + ( ( r * SinArray[s] ) / 100 );
		PlotPixel(x,y,color,where);
	}
}


/*
	The following routines
*/

// allocate our memory to our virtual screen
void SetupVirtual()
{
	Virtual = (unsigned char *) calloc(64000,1);
}

// flip our virtual to our vga
void Flip()
{
	_fmemcpy(vga, Virtual, 64000);
}

// free our memory
void Shutdown()
{
	free(Virtual);
}

// clear a screen
void Cls(unsigned char col, unsigned char *where)
{
	_fmemset(where, col, 64000);
}

void main()
{
	int loop;

	SetMode13h();
	SetupVirtual();		// setup virtual screens
	LoadCircleArrays();	// load our arrays

	for(loop = 50; loop < 55; loop++)		// draw random circles
		Circle(loop*10,50,50,random(256), Virtual);	// draw them to the virtual screen

	printf("PRESS A KEY");
	getch();
	Flip();				// display our screen
	getch();
	Cls(50, vga);       // clear our screen to color 50
	getch();
	Shutdown();
	SetTextMode();
}